<script lang="ts">
  import { focusElement } from '$lib';

  interface Option {
    value: string;
    label: string;
  }

  // Define props
  export let id: string | undefined = undefined;
  export let value: string;
  export let options: Option[];
  export let color = 'slate'; // Note: some colors are added to the safe list in tailwind.config.js to exclude them from purging
  export let extraClasses: string = '';

  let isOpen = false;

  function openMenu() {
    isOpen = true;
    document.body.addEventListener('click', closeMenu);
  }

  function closeMenu() {
    isOpen = false;
    document.body.removeEventListener('click', closeMenu);
  }
</script>

<div class="relative inline-block">
  <button
    on:click|stopPropagation={() => {
      isOpen ? closeMenu() : openMenu();
    }}
    use:focusElement
    {id}
    class="inline-flex items-center rounded-lg px-2.5 py-1.5 font-medium shadow-sm text-{color}-600 hover:text-{color}-700 bg-white hover:bg-{color}-50 border border-{color}-300 hover:border-{color}-400 focus:outline-none focus:ring-4 focus:ring-slate-200 {extraClasses}"
    type="button"
  >
    {options.find((el) => el.value === value)?.label}
    <svg class="-mr-0.5 ml-1.5 h-5 w-5" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"
      ><path
        fill="none"
        stroke="currentColor"
        stroke-linecap="round"
        stroke-linejoin="round"
        stroke-width="2"
        d="m8 9l4-4l4 4m0 6l-4 4l-4-4"
      /></svg
    >
  </button>

  {#if isOpen}
    <div
      class="absolute left-0 z-10 mt-1.5 max-h-[15.25rem] w-48 overflow-y-auto rounded-lg bg-white py-2 text-sm shadow"
    >
      {#each options as option}
        <button
          on:click|stopPropagation={() => {
            value = option.value;
            closeMenu();
          }}
          type="button"
          class="block w-full px-4 py-2 text-left hover:bg-gray-100 hover:text-gray-950"
          >{option.label}</button
        >
      {/each}
    </div>
  {/if}
</div>
